// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "EntityTilePosition.hpp"

using namespace Dawn;

const glm::vec3 EntityTilePosition::toWorldSpace() const {
  return glm::vec3(
    this->x,
    this->y,
    this->z
  );
}

const struct ChunkPosition EntityTilePosition::toChunkPosition() const {
  return {
    (int32_t)(this->x / CHUNK_WIDTH),
    (int32_t)(this->y / CHUNK_HEIGHT),
    (int32_t)(this->z / CHUNK_DEPTH)
  };
}

const struct TilePosition EntityTilePosition::toTilePosition() const {
  return {
    (uint8_t)(this->x % CHUNK_WIDTH),
    (uint8_t)(this->y % CHUNK_HEIGHT),
    (uint8_t)(this->z % CHUNK_DEPTH)
  };
}