// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "component/entity/Entity.hpp"
#include "component/display/Camera.hpp"

namespace Dawn {
  class Player : public Entity {
    protected:
      void updateCameraPosition();

    public:
      std::weak_ptr<Camera> camera;

      void onInit() override;
      void onDispose() override;

      /**
       * Interacts with whatever is in front of the player.
       */
      void interact();
  };
}