// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnlibs.hpp"

namespace Dawn {
  enum class TileID : uint16_t {
    Null = 0,
    Test = 1
  };

  struct TilePosition {
    uint8_t x, y, z;
  };

  union TileData {
    int64_t raw;
  };

  struct Tile {
    enum TileID id;
    union TileData data;

    /**
     * Returns whether or not this tile is solid.
     * 
     * @return Whether or not this tile is solid.
     */
    bool_t isSolid();
  };
}